"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ConstructableUARTInterface = exports.UARTInterface = void 0;
const tiny_typed_emitter_1 = require("tiny-typed-emitter");
const InterfaceType = 'uart';
class UARTInterface extends tiny_typed_emitter_1.TypedEmitter {
    constructor(configuration) {
        super();
        this.interfaceType = InterfaceType;
        this.configuration = configuration;
    }
    retransmit() {
        throw new Error('Method not implemented.');
    }
    // TODO: add real implementation
    downstreamData(data) {
        console.log(data);
    }
    sendFrame(frame) {
        this.emit('upstreamData', frame);
    }
}
exports.UARTInterface = UARTInterface;
class ConstructableUARTInterface {
    constructor(signals) {
        this.interfaceType = InterfaceType;
        this.signals = signals;
    }
    getDescription() {
        return {
            availableSignals: { uart: this.signals },
        };
    }
    create(configuration) {
        return new UARTInterface(configuration);
    }
}
exports.ConstructableUARTInterface = ConstructableUARTInterface;
//# sourceMappingURL=connectionInterface.js.map